<?PHP

@error_reporting(7);
@ini_set('display_errors', true);
@ini_set('html_errors', false);

@session_start();

define('DATALIFEENGINE', true);
define('ROOT_DIR', dirname (__FILE__));
define('ENGINE_DIR', ROOT_DIR.'/engine');

include ENGINE_DIR.'/data/config.php';
require_once ENGINE_DIR.'/inc/mysql.php';
require_once ENGINE_DIR.'/data/dbconfig.php';
require_once ENGINE_DIR.'/modules/functions.php';

	include_once(ENGINE_DIR.'/inc/parse.class.php');
	$parse = new ParseFilter(Array(), Array(), 1, 1);

	@unlink(ENGINE_DIR.'/cache/system/for_cat.php');
	@unlink(ENGINE_DIR.'/cache/system/for_for.php');
	@unlink(ENGINE_DIR.'/cache/system/CatForum.php');
	@unlink(ENGINE_DIR.'/cache/system/ranks.php');
	@unlink(ENGINE_DIR.'/cache/system/mods.php');
	
	$db->query("TRUNCATE TABLE " . PREFIX . "_twsf_categories"); 
	
	$sql = $db->query("SELECT * FROM " . PREFIX . "_forum_categories ORDER BY cat_order ASC"); 
	$i = 0;
	while($row = $db->get_row($sql)){ $i++;
	
	$row['cat_title'] = $db->safesql($parse->process($row['cat_title']));
	$cat_alt_name = totranslit($row['cat_title']);
	$db->query("INSERT INTO " . PREFIX . "_twsf_categories (cat_id, cat_title, cat_order, cat_alt_name) VALUES ('".$row['cat_id']."', '".$row['cat_title']."', '".$i."', '".$cat_alt_name."')");
	
	}
	
	$db->free($sql);
	
	
	
	$db->query("TRUNCATE TABLE " . PREFIX . "_twsf_forums"); 
	
	$sql = $db->query("SELECT * FROM " . PREFIX . "_forum_forums ORDER BY forum_order ASC"); 
	$i = 0;
	while($row = $db->get_row($sql)){ $i++;
	
	$row['forum_name'] = $db->safesql($parse->process($row['forum_name']));
	$alt_name = totranslit($row['forum_name']);
	$db->query("INSERT INTO " . PREFIX . "_twsf_forums VALUES ('".$row['forum_id']."', '".$row['cat_id']."', '".$row['forum_name']."', '".$row['forum_desc']."', 'unlock', '".$i."', '".$row['forum_posts']."', '".$row['forum_topics']."', '".$row['forum_last_post_id']."', '0', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '".$alt_name."', '', '', '', '')");
	
	}
	
	$db->free($sql);


	$db->query("TRUNCATE TABLE " . PREFIX . "_twsf_posts");
	$db->query("TRUNCATE TABLE " . PREFIX . "_twsf_posts_text");
	
	$sql = $db->query("SELECT " . PREFIX . "_forum_posts.*, " . PREFIX . "_users.user_id, " . PREFIX . "_users.name as us_name FROM " . PREFIX . "_forum_posts LEFT JOIN " . PREFIX . "_users ON " . PREFIX . "_users.user_id=" . PREFIX . "_forum_posts.poster_id"); 

	while($row = $db->get_row($sql)){
	
	$row['post_time'] = date ("Y-m-d H:i:s", $row['post_time']);
	if ($row['user_id']){
	$name = $row['us_name'];
	$user_id = $row['user_id'];
	$reg = 1;
	} else {
	$name = $row['post_username'];
	$user_id = 0;
	$reg = 0;
	}
	$db->query("INSERT INTO " . PREFIX . "_twsf_posts VALUES ('".$row['post_id']."', '".$row['topic_id']."', '".$row['forum_id']."', '".$user_id."', '".$name."', '".$reg."', '".$row['post_time']."', '', '', '', '".$row['enable_sig']."', '', '', '0')");
	$db->query("INSERT INTO " . PREFIX . "_twsf_posts_text (t_post_id, text, allow_br) VALUES ('".$row['post_id']."', '".$row['post_text']."', '1')");
	
	}
	
	$db->free($sql);



	$db->query("TRUNCATE TABLE " . PREFIX . "_twsf_topics"); 
	
	$sql = $db->query("SELECT " . PREFIX . "_forum_topics.*, " . PREFIX . "_users.user_id FROM " . PREFIX . "_forum_topics LEFT JOIN " . PREFIX . "_users ON " . PREFIX . "_users.name=" . PREFIX . "_forum_topics.topic_poster"); 

	while($row = $db->get_row($sql)){
	
	$alt_name = totranslit($row['topic_title']);
	$row['topic_time'] = date ("Y-m-d H:i:s", $row['topic_time']);
	if ($row['user_id']){
	$name = $row['topic_poster'];
	$reg = 1;
	} else {
	$name = $row['topic_poster'];
	$reg = 0;
	}
	$db->query("INSERT INTO " . PREFIX . "_twsf_topics VALUES ('".$row['topic_id']."', '".$row['forum_id']."', '".$row['topic_title']."', '".$alt_name."', '".$name."', '".$reg."', '', '".$row['topic_time']."', '".$row['topic_views']."', '".$row['topic_replies']."', '0', '".$row['topic_first_post_id']."', '".$row['lastpostid']."', '0', '0')");
	}
	
	$db->free($sql);
	
	  $post = $db->super_query("SELECT post_id FROM " . PREFIX . "_twsf_posts WHERE forum_id = '0'");
	  if ($post['post_id'] == 0) $mistake = false; else $mistake = true;
	  
	  if ($mistake){
	  $db->query("UPDATE " . PREFIX . "_twsf_posts SET post_id = '0' WHERE topic_id = '0'");
	  
	  $post = $db->super_query("SELECT post_id FROM " . PREFIX . "_twsf_posts WHERE forum_id = '0'");
	  if ($post['post_id'] == 0) $mistake = false; else $mistake = true;
	  }

	  if ($mistake){
	  $db->query("insert into " . PREFIX . "_twsf_posts VALUES (0, 0, 0, 0, '', 0, '0000-00-00 00:00:00', '', '', '', 0, '0000-00-00 00:00:00', 0, 0)");
	  $db->query("UPDATE " . PREFIX . "_twsf_posts SET post_id = '0' WHERE topic_id = '0'");
      }

@header("HTTP/1.0 200 OK");
@header("HTTP/1.1 200 OK");
@header("Cache-Control: no-cache, must-revalidate, max-age=0");
@header("Expires: 0");
@header("Pragma: no-cache");
@header("Content-type: text/css; charset=".$config['charset']);
echo "It`s OK!";
?>