<?php

@session_start();
@error_reporting(E_ALL ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', false);
@ini_set('error_reporting', E_ALL ^ E_NOTICE);

define('DATALIFEENGINE', true);
define('ROOT_DIR', '../../..');
define('ENGINE_DIR', '../..');

include ENGINE_DIR.'/data/config.php';
require_once ENGINE_DIR.'/inc/mysql.php';
require_once ENGINE_DIR.'/data/dbconfig.php';
require_once ROOT_DIR . '/engine/data/forum.config.php';

require_once ENGINE_DIR.'/modules/functions.php';
require_once ENGINE_DIR.'/modules/sitelogin.php';

function votes ($all, $ansid) {

	$data = array();
	$alldata = array();

  if ($all !="") {
     $all = explode("|", $all);
 
     foreach ($all as $vote) {
        list($answerid, $answervalue) = explode(":", $vote);
		$data[$answerid] = intval($answervalue);
      }
  }

    foreach ($ansid as $id) {
	$data[$id] ++;
	}

    foreach ($data as $key => $value) {
$alldata[] = intval($key).":".intval($value);
	}

	$alldata = implode("|", $alldata);
 
   return $alldata;
}

function get_votes ($all) {

	$data = array();

  if ($all != "") {
     $all = explode("|", $all);
 
     foreach ($all as $vote) {
        list($answerid, $answervalue) = explode(":", $vote);
		$data[$answerid] = intval($answervalue);
      }
  }

   return $data;
}

    $top_ID = intval($_REQUEST['news_id']);
    $answers = explode(" ", trim($_REQUEST['answer']));
	$buffer = "";
	$vote_skin = strip_tags($_REQUEST['vote_skin']);
	$_IP = $db->safesql($_SERVER['REMOTE_ADDR']);

	if ($is_logged)
		$log_id = intval($member_id['user_id']);
	else
		$log_id = $_IP;

	$poll = $db->super_query("SELECT * FROM " . PREFIX . "_twsf_poll where top_id = '{$top_ID}'");
    $log  = $db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_twsf_poll_log WHERE top_id = '{$top_ID}' AND member ='{$log_id}'");

	if ($log['count'] AND $_REQUEST['action'] != "list") $_REQUEST['action'] = "results";
	$votes = "";

  if ($_REQUEST['action'] == "vote") {

	$right = $db->super_query("SELECT f.auth_vote, f.moderators, t.topic_lock FROM " . PREFIX . "_twsf_forums f, " . PREFIX . "_twsf_topics t WHERE t.forum_id=f.forum_id AND t.topic_id = '{$top_ID}'");

	if ($right['moderators'] && $is_logged){
			if (strstr($right['moderators'], "$member_id[user_id]")) $ret = $ForConfig['m_voting']; } else $ret = 0;
			
			if (!$right['auth_vote']) $right['auth_vote'] = $ForConfig['s_voting'];
			if (!$member_id[user_group]) $member_id[user_group] = 5;
			if((strstr($right['auth_vote'], "$member_id[user_group]") || $ret == "1") && !$right['topic_lock']){

	$votes = votes ($poll['answer'], $answers);
	$db->query("UPDATE  ".PREFIX."_twsf_poll set answer='$votes', votes=votes+".count($answers)." WHERE top_id = '{$top_ID}'");
	$db->query("INSERT INTO ".PREFIX."_twsf_poll_log (top_id, member) VALUES('{$top_ID}', '$log_id')");
	}
	$_REQUEST['action'] = "results";
  } 

  if ($_REQUEST['action'] == "results")	{

   if ($votes == "") {$votes = $poll['answer']; $allcount = $poll['votes'];} else { $allcount = count($answers) + $poll['votes']; }

   $answer = get_votes ($votes);
   $body  = explode("<br />", stripslashes($poll['body']));
   $pn = 0;

	for ($i = 0; $i < sizeof($body); $i++) {

     $num = $answer[$i];

     if (!$num) $num = 0;

	 ++$pn; if ($pn > 5) $pn = 1;

	 if ($allcount != 0) $proc = (100 * $num) / $allcount;
	 else $proc = 0;

     $proc = round($proc, 0);

$buffer .= <<<HTML
{$body[$i]} - {$num} ({$proc}%)<br />
<img src="{$config['http_home_url']}templates/{$vote_skin}/dleimages/poll{$pn}.gif" height="10" width="{$proc}%" style="border:1px solid black"><br />
HTML;


	}

  } 
  elseif ($_REQUEST['action'] == "list") {

   $body  = explode("<br />", stripslashes($poll['body']));

	if (!$poll['multiple']){

		for ($v = 0; $v < sizeof($body); $v++) {
			if (!$v) $sel = "checked"; else $sel = "";

$buffer .= <<<HTML
<div><input name="dle_poll_votes" id="dle_poll_votes" type="radio" $sel value="{$v}"><label for="dle_poll_votes">{$body[$v]}</label></div>
HTML;

		}
	} else {

		for ($v = 0; $v < sizeof($body); $v++) {

$buffer .= <<<HTML
<div><input name="dle_poll_votes[]" id="dle_poll_votes" type="checkbox" value="{$v}"><label for="dle_poll_votes">{$body[$v]}</label></div>
HTML;

		}

	}


 } else die("error");


@header("HTTP/1.0 200 OK");
@header("HTTP/1.1 200 OK");
@header("Cache-Control: no-cache, must-revalidate, max-age=0");
@header("Expires: 0");
@header("Pragma: no-cache");
@header("Content-type: text/css; charset=".$config['charset']);
echo $buffer;
?>