<?php

error_reporting(7);
ini_set('display_errors', true);
ini_set('html_errors', false);

define('DATALIFEENGINE', true);
define('ROOT_DIR', '../../..');
define('ENGINE_DIR', '../..');

require ENGINE_DIR.'/data/config.php';
require_once ENGINE_DIR.'/inc/mysql.php';
require_once ENGINE_DIR.'/data/dbconfig.php';
require_once ENGINE_DIR.'/modules/functions.php';
require_once ENGINE_DIR.'/inc/parse.class.php';
require_once ENGINE_DIR.'/modules/sitelogin.php';
require_once ENGINE_DIR.'/inc/templates.class.php';

check_xss ();

if ($_COOKIE['dle_skin']) {
	if (@is_dir(ROOT_DIR.'/templates/'.$_COOKIE['dle_skin']))
		{
			$config['skin'] = $_COOKIE['dle_skin'];
		}
}

if ($config["lang_".$config['skin']]) { 

     include_once ROOT_DIR.'/language/'.$config["lang_".$config['skin']].'/website.lng';
	 include_once ROOT_DIR.'/language/'.$config["lang_".$config['skin']].'/forum.web.lng';

} else {

     include_once ROOT_DIR.'/language/'.$config['langs'].'/website.lng';
	 include_once ROOT_DIR.'/language/'.$config['langs'].'/forum.web.lng';
}

$config['charset'] = ($lang['charset'] != '') ? $lang['charset'] : $config['charset'];

include_once ROOT_DIR . '/engine/data/forum.config.php';
if ($ForConfig['skin_name'] != '') $config['skin'] = $ForConfig['skin_name'];

$tpl = new dle_template;
$tpl->dir = ROOT_DIR.'/templates/'.$config['skin'];

$user_group = get_vars ("usergroup");

if (!$user_group) {
  $user_group = array ();

  $db->query("SELECT * FROM " . USERPREFIX . "_usergroups ORDER BY id ASC");

  while($row = $db->get_row()){

   $user_group[$row['id']] = array ();

     foreach ($row as $key => $value)
     {
       $user_group[$row['id']][$key] = $value;
     }

  }
  set_vars ("usergroup", $user_group);
  $db->free();
}

require_once ENGINE_DIR.'/forum/functions.web.php';

@header("HTTP/1.0 200 OK");
@header("HTTP/1.1 200 OK");
@header("Cache-Control: no-cache, must-revalidate, max-age=0");
@header("Expires: 0");
@header("Content-type: text/html; charset=".$config['charset']);

$tpl->load_template('forumtpl/preview.css');

echo <<<HTML
<html><title> </title>
<style type="text/css">
{$tpl->copy_template}
</style> 
<body><center>
HTML;

$tpl->clear();

echo <<<HTML
<script language="javascript" type="text/javascript">
<!--
function ShowBild(sPicURL) {
window.open('{$config['http_home_url']}engine/modules/imagepreview.php?image='+sPicURL, '', 'resizable=1,HEIGHT=200,WIDTH=200, scrollbars=yes');
                        }
//-->
</script>
HTML;

//####################################################################################################################
//                        
//####################################################################################################################

$parse = new ParseFilter(Array(), Array(), 1, 1);

if ($config['allow_site_wysiwyg'] == "yes"){
$short_story = $parse->process($_POST['short_story']);
$title = stripslashes($parse->process($_POST['title']));

$short_story = $parse->BB_Parse($short_story);

} else {
$short_story = $parse->process($_POST['short_story']);
$title = stripslashes($parse->process($_POST['title']));
$short_story = $parse->BB_Parse($short_story, false);
}

    $tpl->load_template('forumtpl/viewtop.tpl');

	if (stristr ($tpl->copy_template, "[xfvalue_")) $xfound = true; else $xfound = false;
    if ($xfound) $xfields = xfieldsload(true);

	////group
	if ($user_group[$member_id['user_group']]['twsf_status'] == 2) $group_name = $user_group[4]['group_name'];
	elseif ($user_group[$member_id['user_group']] == 0 || $user_group[$member_id['user_group']] == "" || !$member_id['user_group']) $group_name = $user_group[5]['group_name'];
	elseif ($member_id['banned'] == 'yes' || $member_id['twsf_active'] == 0) $group_name = $lang['user_ban'];
	else $group_name = $user_group[$member_id['user_group']]['group_name'];
	////avatar
	if ($ForConfig['avatar'] AND $member_id['foto'] AND $member_id['twsf_allowavatar'] AND (file_exists(ROOT_DIR."/uploads/fotos/".$member_id['foto']))) 
	$member_id['foto'] = $config['http_home_url']."uploads/fotos/".$member_id['foto'];
	else $member_id['foto'] = "{THEME}/images/noavatar.png";

	$tpl->set('{edit}', '');
	$tpl->set('{delete}', '');
	$tpl->set('{y_card}', '');
	$tpl->set('{b_card}', '');
	$tpl->set('{r_card}', '');
	
	switch ($member_id['twsf_gender']){
	case 0 : $tpl->set('{gender}', "-"); break;
	case 1 : $tpl->set('{gender}', "<img src=\"{THEME}/forimages/gender_female.gif\" title=\"$lang[u_gen_f]\" border=\"0\" />"); break;
	case 2 : $tpl->set('{gender}', "<img src=\"{THEME}/forimages/gender_male.gif\" title=\"$lang[u_gen_m]\" border=\"0\" />"); break;
	}
	////birthday
	if ($member_id['twsf_birthday'] != '0000-00-00'){
	$member_id['twsf_birthday'] = strtotime($member_id['twsf_birthday']);
	$age = time() - $member_id['twsf_birthday'];
	$tpl->set('{age}',(intval(langdate("Y", $age))-1970));
	$tpl->set('{zod}',get_zodiac($member_id['twsf_birthday']));
	} else {
	$tpl->set('{age}',$FLang['no_age']);
	$tpl->set('{zod}',$FLang['no_zod']);
	}
	
	if ($member_id['user_id']){
    $tpl->set('[not-logged]','');
    $tpl->set('[/not-logged]','');	
	$tpl->set('{pm}', "<a href=\"$config[http_home_url]index.php?do=pm&doaction=newpm&user=".$member_id['user_id']."\"><img src=\"{THEME}/forimages/pm.gif\" title=\"$FLang[send_pm]\" border=\"0\" /></a>");

	if ($ForConfig['allow_alt_url'] == "yes"){
	$tpl->set('{profile}', "<a href=\"".$config['http_home_url']."user/".urlencode($member_id['name'])."/\"><img src=\"{THEME}/forimages/profile.gif\" title=\"$FLang[view_profile]\" border=\"0\" /></a>");
	if ($member_id['msnm']) $tpl->set('{msn}', "<a href=\"".$config['http_home_url']."user/".urlencode($member_id['name'])."/\"><img src=\"{THEME}/forimages/msnm.gif\" title=\"$FLang[us_msn]\" border=\"0\" /></a>"); else $tpl->set('{msn}', "");
	} else {
	$tpl->set('{profile}', "<a href=\"$config[http_home_url]index.php?subaction=userinfo&user=".urlencode($member_id['name'])."\"><img src=\"{THEME}/forimages/profile.gif\" title=\"$FLang[view_profile]\" border=\"0\" /></a>");
	if ($member_id['msnm']) $tpl->set('{msn}', "<a href=\"$config[http_home_url]index.php?subaction=userinfo&user=".urlencode($member_id['name'])."\"><img src=\"{THEME}/forimages/msnm.gif\" title=\"$FLang[us_msn]\" border=\"0\" /></a>"); else $tpl->set('{msn}', "");
	}
	} else {
	$tpl->set_block("'\\[not-logged\\](.*?)\\[/not-logged\\]'si","");
	$tpl->set('{profile}', "");
	$tpl->set('{pm}', "");
	$tpl->set('{msn}', "");
	}

	$tpl->set('{posthref}', "#");
	
	if ($member_id['twsf_rank']) $rangid = $rank[$member_id['twsf_rank']]['rank_id'];
	elseif ($user_group[$member_id['user_group']]['twsf_rang'] && $rank[$user_group[$member_id['user_group']]['twsf_rang']]['rang_spes'] && (!$rank[$user_group[$member_id['user_group']]['twsf_rang']]['rank_min'] || $member_id['twsf_posts'] >= $rank[$user_group[$member_id['user_group']]['twsf_rang']]['rank_min'])) $rangid = $rank[$user_group[$member_id['user_group']]['twsf_rang']]['rank_id'];
	else $rangid = get_usrank($member_id['twsf_posts']);

	if ($rank[$rangid]['rank_image']) $rankimage = "<img src=\"$config[http_home_url]engine/forum/images/ranksicons/".$rank[$rangid]['rank_image']."\" />"; else $rankimage = "";
	
	$news_find = array(
	'{post_id}'			=> '1',
	'{message}'			=> stripslashes($short_story),
	'{date}'			=> Flangdate("j F Y H:i", (time()+($config['date_adjust']*60))),
	'{name}'			=> "<a href=\"#\">".$member_id['name']."</a>",
	'{group}'			=> stripslashes($group_name),
	'{rank}'			=> stripslashes($rank[$rangid]['rank_title']),
	'{rank_img}'		=> $rankimage,
	'{avatar}'			=> $member_id['foto'],
	'{reg_date}'		=> langdate("j F Y H:i", $member_id['reg_date']),
	'{postscount}'		=> $member_id['twsf_posts'],
	'{num}'				=> $i,
	'{warnings}'		=> $member_id['twsf_warnings'],
	'{checkbox}'		=> "",
	);
	
	$tpl->set('',  $news_find);
	unset($news_find);
	
	if ($member_id['icq']){
	$tpl->set('{icq}', "ICQ: ".$member_id['icq']);
	} else $tpl->set('{icq}', "");
	
	if ($member_id['twsf_website'] && $ForConfig['www_allow']) $tpl->set('{www}', "<a href=\"".$member_id['twsf_website']."\"  target=\"_blank\" ><img src=\"{THEME}/forimages/www.gif\" title=\"$FLang[us_www]\" border=\"0\" /></a>"); else $tpl->set('{www}', '');
	
	if ($member_id['allow_mail']){
	$email = explode("@", $member_id['email'], 2);
	$tpl->set('{email}', "<a href=\"$config[http_home_url]index.php?do=feedback&user=$member_id[user_id]\"><img src=\"{THEME}/forimages/email.gif\" title=\"$FLang[send_mail]\" border=\"0\" /></a>");
	}
	else {
	$tpl->set('{email}', '');
	}
	
	if ($member_id['twsf_allow_sig'] && $ForConfig['sign']) $tpl->set('{signature}', stripslashes($member_id['signature'])); else $tpl->set('{signature}', "");
	
	$tpl->set('{ip}', '');

	$tpl->set_block("'\[hide\](.*?)\[/hide\]'i","\\1");
	
	if ( stristr( $tpl->copy_template, "[group=" ) ) {
		$tpl->copy_template = preg_replace( "#\\[group=5\\](.*?)\\[/group\\]#is","", $tpl->copy_template);
		$tpl->copy_template = preg_replace( "#\\[group=(.+?)\\](.*?)\\[/group\\]#is","\\2", $tpl->copy_template);
	}

  if ($xfound) {
    $xfieldsdata = xfieldsdataload ($member_id['xfields']);
  
    foreach ($xfields as $value) {
      $preg_safe_name = preg_quote($value[0], "'");

      if ($is_logged) {
        if (empty($xfieldsdata[$value[0]])) {
          $tpl->copy_template = preg_replace("'\\[xfgiven_{$preg_safe_name}\\](.*?)\\[/xfgiven_{$preg_safe_name}\\]'is", "", $tpl->copy_template);
        } else {
          $tpl->copy_template = preg_replace("'\\[xfgiven_{$preg_safe_name}\\](.*?)\\[/xfgiven_{$preg_safe_name}\\]'is", "\\1", $tpl->copy_template);
        }
      $tpl->copy_template = preg_replace("'\\[xfvalue_{$preg_safe_name}\\]'i", stripslashes($xfieldsdata[$value[0]]), $tpl->copy_template);
      } else {
          $tpl->copy_template = preg_replace("'\\[xfgiven_{$preg_safe_name}\\](.*?)\\[/xfgiven_{$preg_safe_name}\\]'is", "", $tpl->copy_template);
          $tpl->copy_template = preg_replace("'\\[xfvalue_{$preg_safe_name}\\]'i", "", $tpl->copy_template);
		}
    }
  }

	$tpl->set('{THEME}', $config['http_home_url'].'templates/'.$config['skin']);


$tpl->copy_template = "<fieldset style=\"border-style:solid; border-width:1; border-color:black;\"><legend> <span style=\"font-size: 10px; font-family: Verdana\"> :</span> </legend>".$tpl->copy_template."</fieldset>";
$tpl->compile('for.viewtop');
echo $tpl->result['for.viewtop'];

?>
</center></body></html>