<?php
/*
=====================================================
 DataLife Engine - by SoftNews Media Group 
-----------------------------------------------------
 http://dle-news.ru/
-----------------------------------------------------
 Copyright (c) 2004,2007 SoftNews Media Group
=====================================================
     
=====================================================
 : register.php
-----------------------------------------------------
 :  
=====================================================
*/

if(!defined('DATALIFEENGINE'))
{
  die("Hacking attempt!");
}

require_once (ENGINE_DIR.'/inc/parse.class.php');

require_once (ROOT_DIR . '/engine/data/forum.config.php');

function makeDropDown($options, $name, $selected)
    {
        $output = "<select size=1 name=\"$name\">\r\n";
        foreach($options as $value=>$description)
        {
          $output .= "<option value=\"$value\"";
          if($selected == $value){ $output .= " selected "; }
          $output .= ">$description</option>\n";
        }
        $output .= "</select>";
        return $output;
 }

$parse = new ParseFilter();
$parse->safe_mode = true;
$stopregistration = FALSE;

if (isset ($_REQUEST['doaction'])) $doaction = $_REQUEST['doaction']; else $doaction = "";
$config['reg_group'] = intval($config['reg_group']) ? intval($config['reg_group']) : 4;

function check_reg ($name, $email, $password1, $password2, $sec_code=1, $sec_code_session=1) {
	global $lang, $db;
	$stop = "";

    if ( $sec_code != $sec_code_session OR !$sec_code_session) $stop .= $lang['reg_err_19'];
	if ($password1 != $password2) $stop .= $lang['reg_err_1'];
	if (strlen($password1) < 6) $stop .= $lang['reg_err_2'];
	if (strlen($name) > 20) $stop .= $lang['reg_err_3'];
	if (preg_match("/[\||\'|\<|\>|\"|\!|\$|\@|\&\~\*\+]/",$name)) $stop .= $lang['reg_err_4'];
	if ((!ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'. '@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.'[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email)) or (empty($email))) $stop .= $lang['reg_err_6'];
	if (empty($name)) $stop .= $lang['reg_err_7'];

	if ($stop == "")
	{

		@setlocale(LC_CTYPE, array("ru_RU.CP1251", "ru_SU.CP1251", "ru_RU.KOI8-r", "ru_RU", "russian", "ru_SU", "ru"));
		$replace_word = array ('e' => '[e]', 'r' => '[r]', 't' => '[t]', 'y' => '[y]','u' => '[u]','i' => '[i1l!]','o' => '[o0]','p' => '[p]','a' => '[a]','s' => '[s5]','w' => 'w','q' => 'q','d' => 'd','f' => 'f','g' => '[g]','h' => '[h]','j' => 'j','k' => '[k]','l' => '[l1i!]','z' => 'z','x' => '[x%]','c' => '[c]','v' => '[vu]','b' => '[b]','n' => '[n]','m' => '[m]','' => '[u]','' => '','' => '[y]','' => '[e]','' => '[h]','' => '[r]','' => '[w]','' => '[w]','' => '[3]','' => '[x%]','' => '[]','' => '','' => '(|[i1l!]?)','' => '[b]','' => '[a]','' => '[n]','' => '[p]','' => '[o0]','' => '[n]','' => '','' => '','' => '[3]','' => '[]','' => '[4]','' => '[c]','' => '[m]','' => '[u]','' => '[t]','' => '[b]','' => '[6]','' => '(|[!1il][o0])','' => '[e]','1' => '[1il!]','2' => '2','3' => '[3]','4' => '[4]','5' => '[5s]','6' => '[6]','7' => '7','8' => '8','9' => '9','0' => '[0o]','_' => '_','#' => '#','%' => '[%x]','^' => '[^~]','(' => '[(]',')' => '[)]','=' => '=','.' => '[.]','-' => '-');
		$name=strtolower($name);
		$name=strtr($name, $replace_word);

		$row = $db->super_query ("SELECT COUNT(*) as count FROM " . USERPREFIX . "_users WHERE email = '$email' OR LOWER(name) REGEXP '$name'");

        if ($row['count']) $stop .= $lang['reg_err_8'];
	}

return $stop;

}


$row = $db->super_query("SELECT COUNT(*) as count FROM " . USERPREFIX . "_users");

 if ($config['allow_registration'] != "yes") 
 { 

	msgbox ($lang['all_info'], $lang['reg_err_9']); 
    $stopregistration = TRUE;

 } elseif ($config['max_users'] > 0 AND $row['count'] > $config['max_users']) { 

	msgbox ($lang['all_info'], $lang['reg_err_10']); 
    $stopregistration = TRUE;

 }


if (isset($_POST['submit_reg'])) {

	if ($config['allow_sec_code'] == "yes") {
		$sec_code = $_POST['sec_code'];
		$sec_code_session = ($_SESSION['sec_code_session'] != '') ? $_SESSION['sec_code_session'] : false;
	} else {
		$sec_code = 1;
		$sec_code_session = 1;
	}

	$password1 = $db->safesql($parse->process($_POST['password1']));
	$password2 = $db->safesql($parse->process($_POST['password2']));
	$name = $db->safesql($parse->process($_POST['name']));
	$email = $db->safesql($parse->process($_POST['email']));

	$reg_error = check_reg ($name, $email, $password1, $password2, $sec_code, $sec_code_session);

	if (!$reg_error) {

		if ($config['registration_type']) {

	         include_once ENGINE_DIR.'/inc/mail.class.php';
	         $mail = new dle_mail ($config);

			 $row = $db->super_query("SELECT template FROM " . PREFIX . "_email where name='reg_mail' LIMIT 0,1");

			 $row['template'] = stripslashes($row['template']);

			 $idlink = rawurlencode(base64_encode($name."||".$email."||".md5($password1)."||".md5($config['key'])));

			 $row['template'] = str_replace("{%username%}",$name, $row['template']);
			 $row['template'] = str_replace("{%validationlink%}",$config['http_home_url']."index.php?do=register&doaction=validating&id=".$idlink, $row['template']);
			 $row['template'] = str_replace("{%password%}", $password1, $row['template']);

             $mail->send ($email, $lang['reg_subj'], $row['template']);

             if ($mail->send_error) msgbox ($lang['all_info'], $mail->smtp_msg);
	         else msgbox ($lang['reg_vhead'], $lang['reg_vtext']);

 			 $stopregistration = TRUE;

		} else {

			$doaction = "validating";
			$_REQUEST['id'] = rawurlencode(base64_encode($name."||".$email."||".md5($password1)."||".md5($config['key'])));
		}

	} else {msgbox ($lang['reg_err_11'], $reg_error);}

}



if ($doaction != "validating" AND !$stopregistration) {

	$tpl->load_template('registration.tpl');

        $tpl->set('[registration]',"");
        $tpl->set('[/registration]',"");
		$tpl->set_block("'\\[validation\\](.*?)\\[/validation\\]'si","");
		$path = parse_url($config['http_home_url']);

	if ($config['allow_sec_code'] == "yes") {
        $tpl->set('[sec_code]',"");
        $tpl->set('[/sec_code]',"");
		$tpl->set('{reg_code}',"<img src=\"".$path['path']."engine/modules/antibot.php\" alt=\"${lang['sec_image']}\" border=\"0\">");
	} else {
        $tpl->set('{reg_code}',"");
		$tpl->set_block("'\\[sec_code\\](.*?)\\[/sec_code\\]'si","");
	}


$tpl->copy_template = "<form  method=\"post\" name=\"registration\" id=\"registration\" action=\"".$config['http_home_url']."index.php?do=register\">\n".$tpl->copy_template."
<input name=\"submit_reg\" type=\"hidden\" id=\"submit_reg\" value=\"submit_reg\">
</form>";

$tpl->compile('content');
$tpl->clear();

}

if (isset($_POST['submit_val'])) {

	$fullname = $db->safesql($parse->process($_POST['fullname']));
	$land = $db->safesql($parse->process($_POST['land']));
	$icq = $db->safesql($parse->process($_POST['icq']));
	$info = $db->safesql($parse->BB_Parse($parse->process($_POST['info']), false));

////////////
	if ($ForConfig['gender']) $gender = intval($_POST['gender']); else $gender = 0;
	$online = intval($_POST['online']);
	if ($ForConfig['sign']) $signature = $db->safesql($parse->BB_Parse($parse->process($_POST['signature']), false)); else $signature = "";
	$msnm = $db->safesql($parse->process($_POST['msn']));
	if ($ForConfig['www_allow']) $website = $db->safesql($parse->process($_POST['www'])); else $website = "";
	$job = $db->safesql($parse->process($_POST['job']));
	if ($ForConfig['al_sm']) $allowsmile = intval($_POST['smiles']); else $allowsmile = 1;
	if ($ForConfig['ws_alus']){
	$wsnewtop = intval($_POST['wsnewtop']); 
	$wsreply  = intval($_POST['wsreply']);
	} else {
	$wsnewtop = intval($ForConfig['ws_post']);
	$wsreply = intval($ForConfig['ws_rep']);
	}
	///////////

    $image = $_FILES['image']['tmp_name'];
    $image_name = $_FILES['image']['name'];
	$image_size = $_FILES['image']['size'];
    $image_name  = str_replace(" ", "_", $image_name);
	$img_name_arr = explode(".",$image_name);
	$type         = end($img_name_arr);

	$user_arr = explode ("||", base64_decode(rawurldecode($_POST['id'])));
	$user = trim($db->safesql($user_arr[0]));
	$pass = md5($user_arr[2]);

	$db->query("SELECT * FROM " . USERPREFIX . "_users where name = '$user' AND password='$pass'");

	if (!$db->num_rows()) $stop .= "Access Denied"; else $row = $db->get_row();

	$db->free();

	if (is_uploaded_file($image) AND !$stop) {

		if ($image_size < 100000) {

			$allowed_extensions = array("jpg", "png", "jpe", "jpeg", "gif");

				if ((in_array($type, $allowed_extensions) or in_array(strtolower($type), $allowed_extensions)) and $image_name) {

				include_once ENGINE_DIR.'/inc/makethumb.php';

				$res = @move_uploaded_file($image, ROOT_DIR."/uploads/fotos/".$row['user_id'].".".$type);

					if ($res) {

						$thumb=new thumbnail(ROOT_DIR."/uploads/fotos/".$row['user_id'].".".$type);
						$thumb->size_auto($user_group[$config['reg_group']]['max_foto']);	
						$thumb->jpeg_quality($config['jpeg_quality']);
						$thumb->save(ROOT_DIR."/uploads/fotos/foto_".$row['user_id'].".".$type);

						@unlink (ROOT_DIR."/uploads/fotos/".$row['user_id'].".".$type);
						$foto_name = "foto_".$row['user_id'].".".$type;

						$db->query("UPDATE " . USERPREFIX . "_users set foto='$foto_name' where name='$user'");

					} else $stop = $lang['reg_err_12'];
				} else $stop = $lang['reg_err_13'];
		} else $stop = $lang['news_err_16'];
	}

		if (strlen($info) > 500) $stop .= $lang['reg_err_14'];
		if (strlen($fullname) > 100) $stop .= $lang['reg_err_15'];
		if (strlen($land) > 100) $stop .= $lang['reg_err_16'];
		if (strlen($icq) > 20) $stop .= $lang['reg_err_17'];
		/////////
		if (strlen($job) > 200) $stop .= $lang['u_reger1'];
		if (strlen($website) > 200) $stop .= $lang['u_reger2'];
		if (strlen($signature) > intval($ForConfig['max_sign'])) $stop .= $lang['u_reger3'];
		if (trim($_POST['birthday']) != "" && $_POST['birthday'] != '0000-00-00' && $ForConfig['birt'] == '1') {
	if ((($birthday = strtotime($_POST['birthday'])) === -1)) {
	$stop .= $lang['addprof_erdate'];
	} else {
	$birthday = date("Y-m-d", $birthday);
	if ($birthday == date("Y-m-d",$_TIME)) $stop .= $lang['addprof_erdate'];
	}
	} else $birthday = '0000-00-00';
		/////////

	if ($stop){ msgbox ($lang['reg_err_18'], $stop); }
	else {

	$xfieldsaction = "init";
	$xfieldsadd = true;
	include(ENGINE_DIR.'/inc/userfields.php');
	$filecontents = array ();

    if (!empty($postedxfields)) {
      foreach ($postedxfields as $xfielddataname => $xfielddatavalue) {
        if (!$xfielddatavalue) { continue;}

		$xfielddatavalue = $db->safesql($parse->BB_Parse($parse->process($xfielddatavalue), false));

        $xfielddataname = $db->safesql($xfielddataname);

        $xfielddataname = str_replace("|", "&#124;", $xfielddataname);
        $xfielddatavalue = str_replace("|", "&#124;", $xfielddatavalue);
		$filecontents[] = "$xfielddataname|$xfielddatavalue";
      }

      $filecontents = implode("||", $filecontents);
	} else $filecontents = '';

		$db->query("UPDATE " . USERPREFIX . "_users set fullname='$fullname', info='$info', land='$land', icq='$icq', xfields='$filecontents', signature='$signature', twsf_msnm='$msnm', twsf_website='$website', twsf_job='$job', twsf_birthday='$birthday', twsf_gender='$gender', twsf_online='$online', twsf_allowws_top='$wsnewtop', twsf_allowws_post='$wsreply', twsf_allowsmile='$allowsmile' where name='$user'");

		msgbox ($lang['reg_ok'], $lang['reg_ok_1']);

		$stopregistration = TRUE;
	}
}


if ( ($doaction == "validating") AND (!$stopregistration) AND (!$_POST['submit_val']) ) {

	$user_arr = explode ("||", base64_decode(rawurldecode($_REQUEST['id'])));

	$regpassword = md5($user_arr[2]);
	$name = trim($db->safesql($parse->process($user_arr[0])));
	$email = trim($db->safesql($parse->process($user_arr[1])));

	if (md5($config['key']) != $user_arr[3]) die ('ID not valid!');

	$reg_error = check_reg($name, $email, $regpassword, $regpassword);

	if ($reg_error != "") { 
		msgbox ($lang['reg_err_11'], $reg_error); 
		$stopregistration = TRUE; 
	} else {

	if (($_REQUEST['step'] != 2) AND $config['registration_type']) {
		$stopregistration = TRUE;
		$lang['confirm_ok'] = str_replace ('{email}', $email, $lang['confirm_ok']);
		$lang['confirm_ok'] = str_replace ('{login}', $name, $lang['confirm_ok']);
		msgbox ($lang['all_info'], $lang['confirm_ok']. "<br /><br /><a href=\"".$config['http_home_url']."index.php?do=register&doaction=validating&step=2&id=".rawurlencode($_REQUEST['id'])."\">   </a>"); 
	} else {

    $add_time = time()+($config['date_adjust']*60);
	$_IP = $db->safesql($_SERVER['REMOTE_ADDR']);
	if (intval($config['reg_group']) < 3) $config['reg_group'] = 4;

    $db->query("INSERT INTO " . USERPREFIX . "_users (name, password, email, reg_date, lastdate, user_group, logged_ip) VALUES ('$name', '$regpassword', '$email', '$add_time', '$add_time', '".$config['reg_group']."', '".$_IP."')");
	
	@unlink(ENGINE_DIR.'/cache/system/forumcron.php');
	
	}

  }

}

if ($doaction == "validating" AND !$stopregistration) {

	$tpl->load_template('registration.tpl');

        $tpl->set('[validation]',"");
        $tpl->set('[/validation]',"");
		$tpl->set_block("'\\[registration\\].*?\\[/registration\\]'si","");

		$birthday = "<input size=\"17\" name=\"birthday\" id=\"birthday\" class=\"edit\" value=\"0000-00-00\"> <img src=\"engine/skins/images/img.gif\"  align=\"absmiddle\" id=\"t_trigger\" style=\"cursor: pointer; border: 0\" title=\"{$lang['edit_ecal']}\"/>
<script type=\"text/javascript\">
    Calendar.setup({
      inputField     :    \"birthday\",     // id of the input field
      ifFormat       :    \"%Y-%m-%d\",      // format of the input field
      button         :    \"t_trigger\",  // trigger for the calendar (button ID)
      align          :    \"Br\",           // alignment 
	  timeFormat     :    \"24\",
	  showsTime      :    false,
      singleClick    :    true
    });
</script>";
		
		$tpl->set('{online}', makeDropDown(array("1"=>$lang['u_y'],"0"=>$lang['u_n']), "online", 0));
		$tpl->set('{gender}', makeDropDown(array("0"=>$lang['u_gen_n'],"1"=>$lang['u_gen_f'],"2"=>$lang['u_gen_m']), "gender", 0));
        $tpl->set('{birthday}', $birthday);
		$tpl->set('{max}', $ForConfig['max_sign']);
		
		if ($ForConfig['al_sm']) {
        $tpl->set('[/smiles]',"");
		$tpl->set('[smiles]',"");
		$tpl->set('{smiles}', makeDropDown(array("1"=>$lang['u_y'],"0"=>$lang['u_n']), "smiles", 1));
		} else 	$tpl->set_block("'\\[smiles\\].*?\\[/smiles\\]'si","");
		
		if ($ForConfig['ws_alus']){
        $tpl->set('[/wsbb]',"");
		$tpl->set('[wsbb]',"");
		$tpl->set('{wsnewtop}', makeDropDown(array("1"=>$lang['u_ws_ws'],"0"=>$lang['u_ws_bb']), "wsnewtop", $ForConfig['ws_post']));
		$tpl->set('{wsreply}', makeDropDown(array("1"=>$lang['u_ws_ws'],"0"=>$lang['u_ws_bb']), "wsreply", $ForConfig['ws_rep']));
		} else 	$tpl->set_block("'\\[wsbb\\].*?\\[/wsbb\\]'si","");

		  $xfieldsaction = "list";
		  $xfieldsadd = true;
		  include(ENGINE_DIR.'/inc/userfields.php');
          $tpl->set('{xfields}',$output);


$tpl->copy_template = "<form  method=\"post\" name=\"registration\" enctype=\"multipart/form-data\" action=\"".$PHP_SELF."\">\n".$tpl->copy_template."
<input name=\"submit_val\" type=\"hidden\" id=\"submit_val\" value=\"submit_val\">
<input name=\"do\" type=\"hidden\" id=\"do\" value=\"register\">
<input name=\"doaction\" type=\"hidden\" id=\"doaction\" value=\"validating\">
<input name=\"id\" type=\"hidden\" id=\"id\" value=\"{$_REQUEST['id']}\">
</form>";

	$tpl->compile('content');
	$tpl->clear();
}

?>